Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j
Class MDC

    java.lang.Object
      org.apache.log4j.MDC

    public class MDC

extends java.lang.Object

The MDC class is similar to the `NDC` class except that it is based on a map instead of a stack. It provides mapped diagnostic contexts. A Mapped Diagnostic Context, or MDC in short, is an instrument for distinguishing interleaved log output from different sources. Log output is typically interleaved when a server handles multiple clients near-simultaneously.

The MDC is managed on a per thread basis. A child thread automatically inherits a copy of the mapped diagnostic context of its parent.

The MDC class requires JDK 1.2 or above. Under JDK 1.1 the MDC will always return empty values but otherwise will not affect or harm your application.

Since:
  1.2
Author:
  Ceki Gülcü

Method Summary
`static java.lang.Object` | `get(java.lang.String key)` Get the context identified by the `key` parameter.
`static java.util.Hashtable` | `getContext()` Get the current thread's MDC as a hashtable.
`static void` | `put(java.lang.String key, java.lang.Object o)` Put a context value (the `o` parameter) as identified with the `key` parameter into the current thread's context map.
`static void` | `remove(java.lang.String key)` Remove the the context identified by the `key` parameter.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### put

    public static void put(java.lang.String key,
                           java.lang.Object o)

  Put a context value (the `o` parameter) as identified with the `key` parameter into the current thread's context map.

  If the current thread does not have a context map it is created as a side effect.

### get

    public static java.lang.Object get(java.lang.String key)

  Get the context identified by the `key` parameter.

  This method has no side effects.

### remove

    public static void remove(java.lang.String key)

  Remove the the context identified by the `key` parameter.

### getContext

    public static java.util.Hashtable getContext()

  Get the current thread's MDC as a hashtable. This method is intended to be used internally.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2007 Apache Software Foundation. All Rights Reserved.